/*
	Author: pnminh.it@gmail.com
	De Bai: Xay dung lop Da Thuc
		+ constructor
		+ deconstructor
		+ ham nhap
		+ ham xuat

*/
#include "iostream.h"
#include "conio.h"

class dathuc{
	private:
		int n;//so bac cua da thuc
		long *a;//luu gia tri a0-an
	public:
		dathuc();
		dathuc(int n1);//constructor 1 tham so mac dinh
		dathuc(int n1,long *v);//constructor 2 tham so mac dinh
		~dathuc();//deconstructor <constructor huy>
		dathuc(const dathuc &d);//constructor sao chep
		void nhap();// ham nhap gia tri da thuc
		void xuat();// ham in da thuc
		friend ostream&operator<<(ostream&os,dathuc&d);//da nang hoa toan tu Xuat Cout<<
		friend istream&operator>>(istream&is,dathuc&d);//da nang hoa toan tu Nhap Cin>>
		dathuc operator+(dathuc &d);//dinh nghia toan tu Cong +
		dathuc operator-(dathuc &d);//dinh nghia toan tu Hieu -
		dathuc operator*(dathuc &d);//dinh nghia toan tu nhan *
		dathuc operator/(dathuc &d);//dinh nghia toan tu chia /
};
//constructor mac dinh
dathuc::dathuc(){
	n = 20;
	a = new long[n+1];
	for(int i=0;i<=n;i++)
		a[i] = 0;
}

//constructor 1 tham so
dathuc::dathuc(int n1){
	n = n1;
	a = new long[n+1];
	for(int i=0;i<=n;i++)
		a[i] = 0;
}

//constructor 2 tham so
dathuc::dathuc(int n1,long *v){
	n = n1;
	a = new long[n+1];
	for(int i=0;i<=n;i++)
		a[i] = v[i];
}

//deconstructor
dathuc::~dathuc(){
	cout<<"\nHuy Constructor ";
	delete[] a;
}

//constructor sao chep
dathuc::dathuc(const dathuc &d){
	n = d.n;
	a = new long[n+1];
	for(int i=0;i<=n;i++)
		a[i] = d.a[i];
}
//ham nhap da thuc
void dathuc::nhap(){
	if(a!=NULL) delete a;
	cout<<"\nNhap So Bac: "; cin>>n;
	cout<<"\nNhap He So Da Thuc\n";
	for(int i=0;i<=n;i++){
		cout<<"a["<<i<<"] = "; cin>>a[i];
	}
}

//ham in da thuc
void dathuc::xuat(){
	cout<<"\nDa Thuc: \n";
	for(int i=0;i<=n;i++)
		cout<<a[i]<<" ";
	cout<<endl;
}

//dinh nghia chong ham toan tu xuat Cout<<
ostream&operator<<(ostream&os,dathuc&d){
	os<<"\nDa Thuc\n";
	for(int i=0;i<=d.n;i++){
		os<<d.a[i]<<" ";
	}
	return os;
}

//dinh nghia chong ham toan tu nhap cin>>
istream&operator>>(istream&is,dathuc&d){
	if(d.a!=NULL) delete d.a;
	cout<<"\nNhap So Bac: "; is>>d.n;
	cout<<"\nNhap He So: ";
	for(int i=0;i<=d.n;i++){
		cout<<"\na["<<i<<"] = "; is>>d.a[i];
	}
	return is;
}
//dinh nghia chong ham toan tu +
dathuc dathuc::operator+(dathuc &d){
	int k = n > d.n ? n:d.n;
	dathuc f(k);
	for(int i=0;i<=k;i++){
		if(n>=i && d.n>=i)
			f.a[i] = a[i] + d.a[i];
		else
			if(d.n >= i)
				f.a[i] = d.a[i];
			else
				f.a[i] = a[i];


	}
	while(k>0 && f.a[i]==0) k--;
	f.n = k;
	return f;
}
dathuc dathuc::operator-(dathuc &d){
	int k = n > d.n ? n:d.n;
	dathuc f(k);
	for(int i=0;i<=k;i++){
		if(n>=i && d.n >=i)
			f.a[i] = a[i] - d.a[i];
		else
			if(d.n >= i)
				f.a[i] = d.a[i];
			else //if(n < i)
				f.a[i] = a[i];
	}
	f.n = k;
	return f;
}
dathuc dathuc::operator*(dathuc &d){
	int k = n + d.n;
	dathuc f(k);
	for(int i=0;i<=k;i++) f.a[i] = 0;
	for(i=0;i<=n;i++)
	for(int j=0;j<=d.n;j++)
		f.a[i+j] =f.a[i+j] + a[i]*d.a[j];
	return f;
}
dathuc dathuc::operator/(dathuc &d){
	int k;
	if(n > d.n) return 0;
	k = n - d.n;
	dathuc f(k);
	dathuc temp(*this);
	for(int i=n;i>=d.n;i--,k--){
		f.a[i-d.n] = temp.a[i] / d.a[d.n];
		if(i-1 >=d.n){
			for(int j=i-1,k=d.n - 1;k>=0;j--,k--)
				temp.a[j] = temp.a[j] - f.a[i-d.n] * d.a[k];
		}
	}
	return f;
}

void main(){
	clrscr();
	dathuc a,b,c,d,e,f;
	cin>>a;
	cin>>b;
	cout<<a;
	cout<<b;
	c = a+b;
	cout<<"\nA + B = \n";
	c.xuat();
	d = a - b;
	cout<<"\nA - B = \n";
	d.xuat();
	e = a * b;
	cout<<"\nA * B = \n";
	e.xuat();
	f = a / b;
	cout<<"\nA / B = \n";
	f.xuat();
	getch();
}