/*
 + Author:pnminh.it@gmail.com
 + De bai: Xay Dung 1 lop vector gom co cac thanh phan sau:
	+ cac thuoc tinh: n(cap cua vector), *v(toa do diem cua vector)
	+ ham thiet lap khong tham so
	+ ham thiet lap co tham so
	+ ham sao chep
	+ ham huy // ~vector
	- Cac ham chong toan tu:
	+ toan tu gan ( = )
	+ toan tu so sanh bang ( == )
	+ toan tu so sanh khac ( != )
	+ toan tu lay phan tu tai chi so []
	+ toan tu nhap >>
	+ toan tu xuat <<
	+ dinh nghia chong toan tu +,-,*
	+ dinh nghia chong toan tu +,-,/ 1 vector cho 1 so nguyen( hoac Thuc)
	+ dem so luong cac vector nhap vao su dung ham static
+)NOTE: chu y cach su dung ham static

*/

#include "iostream.h"
#include "conio.h"

class vector{
	private:
		int n;//cap vector
		int *v;//toa do diem
		static int count;//bien dem (neu can)
	public:
		vector();//constructor mac dinh
		vector(int n1,int *a);//constructor co tham so
		vector(const vector&s);//constructor sao chep
		~vector();//ham deconstructor
		friend ostream&operator<<(ostream&os,vector&s);
		friend istream&operator>>(istream&is,vector&s);
		vector operator=(vector&s);//ham gan =
		int operator==(vector &s);//chong ham so sanh ==
		int operator!=(vector &s);//chong ham so sanh khach nhau !=
		int operator[](int);//dinh nghia toan tu lay gia tri cua vector
		static int getcount();
		vector operator+(vector&s);//cong 2 vector
		vector operator-(vector&s);//tru 2 vector
		vector operator*(vector&s);//nhan 2 vector
		vector operator*(int a);//nhan 1 vector voi 1 so nguyen
		vector operator/(int a);//chia 1 vector cho 1 so nguyen

};
int vector::count=0;//khai bao khoi tao gia tri cho ham static
//ham lay ra gia tri cua bien dem count
int vector::getcount(){
	return count;
}
//ham dinh nghia constructor
vector::vector(){
	n = 10;
	v = new int[n];
	for(int i=0;i<n;i++)
		v[i] = 0;
		count++;
}
//ham dinh nghia constructor co tham so
vector::vector(int n1,int *a){
	n = n1;
	v = new int[n];
	for(int i=0;i<n;i++)
		v[i] = a[i];
		count++;
}
//ham dinh nghia constructor sao chep
vector::vector(const vector &s){
	n = s.n;
	v = new int[n];
	for(int i=0;i<n;i++)
		v[i] = s.v[i];
		count++;
}
//ham huy constructor
vector::~vector(){
	delete []v;
	count--;
}
//dinh nghia chong toan tu xuat <<
ostream&operator<<(ostream&os,vector&s){
	for(int i=0;i<s.n;i++){
		os<<s.v[i]<<" ";
	}
	cout<<endl;
	return os;
}
//dinh nghia ham chong toan tu nhap cin >>
istream&operator>>(istream&is,vector&s){
	cout<<"\nNhap So Phan Tu: "; is>>s.n;
	for(int i=0;i<s.n;i++){
		cout<<"\nphan tu thu: "<<i+1<<": ";
		is>>s.v[i];
	}
	return is;
}
//dinh nghia chong toan tu gan =
vector vector::operator=(vector &s){
	if(this!=&s){
		if(n!=s.n){
			delete v;
			n = s.n;
			v = new int[n];
		}
		for(int i=0;i<n;i++){
			v[i] = s.v[i];
		}

	}else
		cout<<"giong nhau"<<endl;
	return *this;
}
//dinh nghia chong toan tu so sanh ==
int vector::operator==(vector &s){
	if(n!=s.n)
		return 0;
	for(int i=0;i<n;i++)
		if(v[i]!=s.v[i])
			return 0;
	return 1;
}
//ham so sanh khac nhau
int vector::operator!=(vector &s){
	return !(*this==s);
}
//ham lay ra gia tri
int vector::operator[](int index){
	return v[index];
}
//chong ham toan tu cong 2 vector +
vector vector::operator+(vector &s){
	if(n == s.n){
		for(int i=0;i<n;i++)
			v[i] = v[i] + s.v[i];
	}else{
		cout<<"\nKhong the cong";
	}
	return *this;
}
vector vector::operator-(vector &s){
	if(n == s.n){
		for(int i=0;i<n;i++)
			v[i] += s.v[i];
	}else
		cout<<"\nkhong tru duoc";
	return *this;
}

//chong toan tu Nhan 2 vector *
vector vector::operator*(vector &s){
	for(int i=0;i<n;i++)
		v[i]*=s.v[i];
	return *this;
}
//chong toan tu Nhan 1 vector voi 1 so nguyen
vector vector::operator*(int a){
	for(int i=0;i<n;i++)
		v[i]*=a;
	return *this;
}
//chong toan tu Chia 1 vector voi 1 so nguyen
vector vector::operator/(int a){
	for(int i=0;i<n;i++)
		v[i] /=a;
	return *this;
}

void main(){
	clrscr();
	vector v;//tao va kiem tra ham thiet lap ko tham so
	cout<<v;
	int a[4] = {1,3,4,5};
	vector v1(4,a);//kiem tra ham thiet lap co tham so
	cout<<v1;//kiem tra ham thiet lap xuat cout<<
	vector v2(v1);//kiem tra ham sao chep
	cout<<v2;
	vector v3;
	cin>>v3;// kiem tra toan tu nhap cin>>
	cout<<"\nV3 = "<<v3;
	v = v3;//kiem tra toan tu gan =
	cout<<"v = "<<v;
	if(v3==v){//kiem tra ham so sanh
		cout<<"v3 == v";
	}else{
		cout<<"v3 != v";
	}
	cout<<"\nv[0]= "<<v[0];//kiem tra ham lay gia tri
	vector v5 = v3+v1;
	cout<<"\nV3 + V1 = "<<v5;
	vector v6 = v3*3;
	cout<<"\nV3 * 3 = "<<v6;
	vector v7 = v1/2;
	cout<<"\nV3 / 2 = "<<v7;//kiem tra ham chia tra ve kieu so nguyen
	cout<<"\nSo Vector duoc khoi tao la: "<<vector::getcount();
	getch();
}